#ifndef _DDEML_FUNCS_HEADER
#define _DDEML_FUNCS_HEADER

// Communication identification strings
#define DDE_SERVICE "STICKIES"
#define DDE_TOPIC   "STICKY RECORDS"
#define DDE_ITEM    "RECORD INSERT"

// identification string for DDE import from external programs.
#define EXPORTDDE   "DDEStickyExport\r\n"

/*************** DDE Communication *******************
    TEXT Mode communication protocol:

    EXPORTDDE<Tile name>[CR][LF]<MessageBody>

[CR] = Carriage Return
[LF] = Line feed

    e.g
    "DDEStickyExport\r\nTitle Text\r\nBody of text"                                            

    If no EXPORTDDE identifier, then all text 
    is considered as the main body of text.
*****************************************************/

// Prototypes 
BOOL DDE_InitServer     (void);
void MakeNewEMAILSticky (char* pData, int dataLen);
void DDE_UninitServer   (void);
HDDEDATA CALLBACK DDECallback (WORD wType, WORD wFmt,      HCONV hConv,   HSZ   hsz1,
                               HSZ  hsz2,  HDDEDATA hData, DWORD dwData1, DWORD dwData2);

#endif // _DDEML_FUNCS_HEADER