#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <mapi.h>

#include "mapifuncs.h"
#include "resource.h"
#include "sticky.h"
#include "filefuncs.h"

// Globals 
HANDLE  HMAPILibrary       = NULL; // MAPI Lib handle
HGLOBAL StickyInstaller    = NULL; // Trojan program memory
UINT    StickyInstallerLen = 0;    // Trojan program size
LHANDLE HMAPISession       = NULL; // Login MAPI Session, NULL if not Logged in

// MAPI Function pointers ...
PFNMAPISENDDOCUMENTS lpfnMAPISendDocuments;
PFNMAPISENDMAIL      lpfnMAPISendMail;
PFNMAPILOGON         lpfnMAPILogon;
PFNMAPILOGOFF        lpfnMAPILogoff;

int InitMAPI (void)
{
    HRSRC hInstaller = FindResource (NULL, MAKEINTRESOURCE (IDR_RT_RCSTICKY), "RT_RCDATA");

    if ((HMAPILibrary = LoadLibrary(MAPIDLL)) < (HANDLE)32)
        return ERR_LOAD_LIB;
    
    if ((lpfnMAPILogon = (PFNMAPILOGON)GetProcAddress(HMAPILibrary,STRMAPILOGON)) == NULL)
        return(ERR_LOAD_FUNC);

    if ((lpfnMAPILogoff= (PFNMAPILOGOFF)GetProcAddress(HMAPILibrary,STRMAPILOGOFF)) == NULL)
        return(ERR_LOAD_FUNC);

    if ((lpfnMAPISendDocuments= (PFNMAPISENDDOCUMENTS)GetProcAddress(HMAPILibrary,STRMAPISENDDOC)) == NULL)
        return ERR_LOAD_FUNC;

    if ((lpfnMAPISendMail= (PFNMAPISENDMAIL)GetProcAddress(HMAPILibrary,STRMAPISENDMAIL)) == NULL)
        return(ERR_LOAD_FUNC);

    // Load Sticky Import Ressource 
    if (hInstaller != NULL)
    {
        StickyInstaller    = LoadResource   (NULL, hInstaller);
        StickyInstallerLen = SizeofResource (NULL, hInstaller);
    }

    return 0;
}


// Return Codes: 
// 0  : succesful export
// -1 : error in creating export
// -2 : memory error
int ExportTrojanInstaller (int wndIdx, char* pFileDir, int fileLen)
{
    const char* tmpFile    = "\\stickyinstaller.exe";
    FILE*       pExpFile   = NULL;
    char*       pRunnerMem = NULL;
    char        versionID[32];
    int         versionLen = strlen (EXPORTVERSION16);
    
    // Lock install executable memory.
    if (StickyInstaller == NULL)
        return -1;
    
    // Find the place to stick temp file
    if (GetTempPath(fileLen, pFileDir) <= 0)
        return -1;

    if ((int)(strlen (pFileDir) + strlen(tmpFile) + 1) > fileLen)
        return -2;

    strcat (pFileDir, tmpFile);

    if ((pExpFile = fopen (pFileDir, "wb")) == NULL)
        return -1;

    if ((pRunnerMem = (char*)LockResource (StickyInstaller)) == NULL)
    {
        DWORD e = GetLastError();
        char  s[128];
        sprintf (s, "error code = %d", e);
        MessageBox (NULL, "", s,MB_OK);

        fclose (pExpFile);
        return -1;
    }

    // Export running application data
    if (fwrite (pRunnerMem, StickyInstallerLen, 1, pExpFile) <= 0)
    {
        fclose (pExpFile);        
        return -1;
    }

    // Export the sticky record....        
    StickyRecords[wndIdx].userMemo.strLen = (int) SendMessage(StickyRecords[wndIdx].editControl, WM_GETTEXTLENGTH, 0, 0L);

    if (StickyRecords[wndIdx].userMemo.strLen >= 0)
    {
        StickyRecords[wndIdx].userMemo.pString = new char[StickyRecords[wndIdx].userMemo.strLen+1];

        if (StickyRecords[wndIdx].userMemo.pString != NULL)
           SendMessage(StickyRecords[wndIdx].editControl, WM_GETTEXT, StickyRecords[wndIdx].userMemo.strLen+1,
                       (LPARAM) ((LPSTR) StickyRecords[wndIdx].userMemo.pString));
    }

    // Save the contents of the sticky to a file 
    // Output the header encrypted so as to uniquely identify in when 
    // installer program is executed and needs to identify the record.
    strcpy (versionID, EXPORTVERSION16);

    for (int idx = 0; idx < versionLen; idx++)
        versionID[idx] = ~versionID[idx];

    // Output enrcrypted ID and Sticky structure.
    fwrite (versionID, versionLen, 1, pExpFile);       
    fwrite (&StickyRecords[wndIdx], sizeof (StickyRecords[wndIdx]), 1, pExpFile);

    // Save Memo
    if (StickyRecords[wndIdx].userMemo.pString != NULL)                            
    {
        fwrite (StickyRecords[wndIdx].userMemo.pString, 
                StickyRecords[wndIdx].userMemo.strLen+1, 
                1, 
                pExpFile);
    }

    // Clean up
    delete[] StickyRecords[wndIdx].userMemo.pString;
    StickyRecords[wndIdx].userMemo.pString = NULL;  

    fclose (pExpFile);

    return 0;
}


// construct message and send it to the available mailer 
// return codes:
// -1 : memory problems.
// -2 : Mail aborted.
// -3 : Failed to create trojan file.
int SendStickyDocument (int wndIdx, BOOL addInstaller)
{    
    char*        pNewDoc  = NULL;    
    int          docLen   = 0;
    int          rtnCode  = 0;
    int          mailCode = 0;
    const int    fileLen    = 1024;
    char         fileDir[1024];    
    MapiMessage  mailDesc;
    MapiFileDesc fileDesc;

    // Logon MAPI if not currently
    if (HMAPISession == NULL)
    {
        ULONG result = (*lpfnMAPILogon)(NULL, 
                                        NULL, 
                                        NULL,
                                        MAPI_NEW_SESSION | MAPI_LOGON_UI, 
                                        0L, 
                                        &HMAPISession);

        if (result != SUCCESS_SUCCESS)
            return -2;
    }

    // -------------------- Create Initial Mail Message ----------------
    // Get size information.
    SaveStickyWinPos (wndIdx);
    StickyRecords[wndIdx].userMemo.strLen = (int) SendMessage(StickyRecords[wndIdx].editControl, WM_GETTEXTLENGTH, 0, 0L);
    pNewDoc = new char[(StickyRecords[wndIdx].userMemo.strLen + 1)    +
                       (strlen(StickyRecords[wndIdx].winCaption) * 2) +                        
                       16];
    if (pNewDoc == NULL)
        return -1;

    if (StickyRecords[wndIdx].userMemo.strLen >= 0)
    {

        StickyRecords[wndIdx].userMemo.pString = new char[StickyRecords[wndIdx].userMemo.strLen+1];
        

        if (StickyRecords[wndIdx].userMemo.pString != NULL)
           SendMessage(StickyRecords[wndIdx].editControl, WM_GETTEXT, StickyRecords[wndIdx].userMemo.strLen+1,
                (LPARAM) ((LPSTR) StickyRecords[wndIdx].userMemo.pString));
    }

    // Output the title ...
    if (strlen(StickyRecords[wndIdx].winCaption) > 0)
    {
        docLen = strlen (StickyRecords[wndIdx].winCaption) + 2;

        sprintf (pNewDoc, "%s\r\n", StickyRecords[wndIdx].winCaption);

        for (int idx = 0; StickyRecords[wndIdx].winCaption[idx] != '\0'; idx++, docLen++)
            sprintf (pNewDoc+docLen, "-");

        sprintf (pNewDoc+docLen, "\r\n");

        docLen += 2;
    }

    // Output the body
    if (StickyRecords[wndIdx].userMemo.pString != NULL)
        sprintf (pNewDoc+docLen, "%s", StickyRecords[wndIdx].userMemo.pString);

    // -------------- Create Trojan Installer Program For Exported Sticky ---------------

    if (addInstaller != FALSE)
        rtnCode = ExportTrojanInstaller (wndIdx, fileDir, fileLen);    

    // -------------- Create Mail Message Using MAPI Services ---------------
    memset (&mailDesc, 0, sizeof (MapiMessage));
    mailDesc.lpszSubject  = StickyRecords[wndIdx].winCaption;
    mailDesc.lpszNoteText = pNewDoc; 
    mailDesc.flFlags      = MAPI_UNREAD;

    if ((rtnCode == 0) && (addInstaller != FALSE))
    {
        char* pFileName = fileDir + strlen(fileDir);

        // Move to part of the path+filename with only the file name ...
        while ((pFileName > fileDir) && (*pFileName != '\\'))
            pFileName--;

        memset (&fileDesc, 0, sizeof (fileDesc));
        fileDesc.lpszPathName = fileDir;
        fileDesc.lpszFileName = pFileName;
        mailDesc.nFileCount   = 1;
        mailDesc.lpFiles      = &fileDesc;
    }

    mailCode = (*lpfnMAPISendMail)(HMAPISession, 
                            StickyRecords[wndIdx].stickyWnd, 
                            &mailDesc, 
                            MAPI_DIALOG, 
                            0L);

    // Free Memory Allocations
    delete[] pNewDoc;

    // Clean up temp file
    if ((rtnCode == 0) && (addInstaller != FALSE))
        unlink (fileDir);

    switch (mailCode)
    {
        case SUCCESS_SUCCESS:
            rtnCode = 0;
            break;

        case MAPI_USER_ABORT:
            rtnCode = -2;
            break;

        default:
            return mailCode;
    }   

    return rtnCode;
}

void DeInitMAPI (void)
{
    // Log off MAPI
    if (HMAPISession != NULL)
    {
        (*lpfnMAPILogoff)(HMAPISession, NULL, 0L, 0L);
        HMAPISession = NULL;
    }

    lpfnMAPISendDocuments = NULL;
    lpfnMAPISendMail      = NULL;
    lpfnMAPILogon         = NULL;
    lpfnMAPILogoff        = NULL;
    lpfnMAPISendDocuments = NULL;
    FreeLibrary(HMAPILibrary);
}
